<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "widget".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Widget".
 *
 * Columns in table "widget" available as properties of the model,
 * followed by relations of table "widget" available as properties of the model.
 *
 * @property integer $id
 * @property integer $account_id
 * @property integer $hidden
 * @property integer $draft
 * @property string $key_code
 * @property string $name
 * @property string $widget_type
 * @property string $options
 *
 * @property ProviderPracticeWidget[] $providerPracticeWidgets
 * @property ProviderRatingWidget[] $providerRatingWidgets
 * @property WidgetUrl[] $widgetUrls
 * @property Account $account
 */
abstract class BaseWidget extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'widget';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Widget|Widgets', $n);
    }

    public static function representingColumn()
    {
        return 'key_code';
    }

    public function rules()
    {
        return array(
            array('account_id, key_code, name, options', 'required'),
            array('account_id, hidden, draft', 'numerical', 'integerOnly' => true),
            array('key_code, name', 'length', 'max' => 32),
            array('widget_type', 'length', 'max' => 20),
            array('hidden, draft, widget_type', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, account_id, hidden, draft, key_code, name, widget_type, options', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'providerPracticeWidgets' => array(self::HAS_MANY, 'ProviderPracticeWidget', 'widget_id'),
            'providerRatingWidgets' => array(self::HAS_MANY, 'ProviderRatingWidget', 'widget_id'),
            'widgetUrls' => array(self::HAS_MANY, 'WidgetUrl', 'widget_id'),
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_id' => null,
            'hidden' => Yii::t('app', 'Hidden'),
            'draft' => Yii::t('app', 'Draft'),
            'key_code' => Yii::t('app', 'Key Code'),
            'name' => Yii::t('app', 'Name'),
            'widget_type' => Yii::t('app', 'Widget Type'),
            'options' => Yii::t('app', 'Options'),
            'providerPracticeWidgets' => null,
            'providerRatingWidgets' => null,
            'account' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('hidden', $this->hidden);
        $criteria->compare('draft', $this->draft);
        $criteria->compare('key_code', $this->key_code, true);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('widget_type', $this->widget_type, true);
        $criteria->compare('options', $this->options, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
